class LINE inherit PRIMITIVE
	-- Objekte reprsentieren eine Linie

creation
	make

feature {ANY}
	-- Das Konzept der Besucher erfordert, da hier alles von
	-- auen zugnglich ist
	-- Hinweis: Das ist ein Nachteil des Besucher-Konzepts

	first, last: POINT;
		-- Anfangs- und Endpunkt

	receive (v: GOVISITOR) is
		-- Besucher empfangen
		-- require in PRIMITIVE beachten
		do
			v.visitLINE (current);
		end;

	paint (dc: WEL_CLIENT_DC) is
		-- require in PRIMITIVE beachten
		do
			dc.line (first.x.rounded, first.y.rounded,
				last.x.rounded, last.y.rounded);
		end;

	textout is
		do
			io.putstring ("[LINE: ");
			first.textout;
			last.textout;
			io.putstring ("] ");		
		end;

	make (xa, ya, xe, ye: REAL) is
		require
			xa /= xe OR ya /= ye;
		do
			!!first.make (xa, ya);
			!!last.make (xe, ye);
		end;

	invariant
			first /= VOID;
			last /= VOID;

end --class LINE
